'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var scrollItems = {
  PRIMARY_SCROLLTOP_KEY: 0
};

var ScrollRevert = function (_React$Component) {
  _inherits(ScrollRevert, _React$Component);

  function ScrollRevert() {
    _classCallCheck(this, ScrollRevert);

    return _possibleConstructorReturn(this, (ScrollRevert.__proto__ || Object.getPrototypeOf(ScrollRevert)).apply(this, arguments));
  }

  _createClass(ScrollRevert, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var scrollKey = this.props.scrollKey;

      typeof scrollKey === 'undefined' || scrollKey === null ? scrollKey = 'PRIMARY_SCROLLTOP_KEY' : '';
      this.getContainer() ? this.getContainer().scrollTop = scrollItems[scrollKey] : '';
    }
  }, {
    key: 'getContainer',
    value: function getContainer() {
      var rootwrappedComponent = this.props.rootwrappedComponent;

      if (typeof rootwrappedComponent === 'undefined' || rootwrappedComponent === null) {
        rootwrappedComponent = document.getElementById('root');
        console.error('ScrollRevert组件 rootwrappedComponent属性必传！');
      }
      return rootwrappedComponent;
    }
  }, {
    key: 'handleScrollTop',
    value: function handleScrollTop() {
      var scrollKey = this.props.scrollKey;

      typeof scrollKey === 'undefined' || scrollKey === null ? scrollKey = 'PRIMARY_SCROLLTOP_KEY' : '';
      var ele = this.getContainer();
      scrollItems[scrollKey] = typeof ele.scrollTop === 'undefined' ? 0 : ele.scrollTop;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var children = this.props.children;

      return _react2.default.createElement(
        'div',
        {
          onClick: function onClick(e) {
            _this2.handleScrollTop();
          }
        },
        children
      );
    }
  }]);

  return ScrollRevert;
}(_react2.default.Component);

exports.default = ScrollRevert;


ScrollRevert.propTypes = {
  children: _propTypes2.default.any,
  rootwrappedComponent: _propTypes2.default.object,
  scrollKey: _propTypes2.default.string
};
module.exports = exports['default'];